;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~        (C) Copyright raphi Software 2004 - All Rights Reserved      ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~ Author : Raphal PASQUIER                                           ~
;~ Email  : raphael.pasquier@neuf.fr                                   ~
;~ Version: 0.0.0.2                                                    ~
;~ Date   : 13/07/2005                                                 ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~    exemple d' utilisation de yasm et du C avec gcc sur GNU/linux    ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~  yasm -m amd64 -f elf software.asm -o software.o                    ~
;~                                                                     ~
;~  gcc -m64 software.o main.c -o main                                 ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~ Description : fait la somme de deux entiers longs positifs          ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BITS 64
	
GLOBAL divB_R_x86_64_bini


; en C => unsigned long int divB_R_x86_64_bini( Lii* a , unsigned long int D ) ;
;  0 < D < 2^64

; J' utilise l' instruction div qui est trs lente :
; div reg16  ==> 23 cycles
; div reg32  ==> 39 cycles
; div reg64  ==> 71 cycles

; 

divB_R_x86_64_bini:

	mov rcx, [rdi]  ; rcx = signe de a
	test rcx, rcx
	jnz non_nul
	ret 


non_nul:
	; ***  initialisation   ***
	;
	; rdx:rax = pour le rsultat de la division reste:quotient 
	; rcx = indiceMax
	; r8  = adresse mantisse
	; r9  = tempon 
	;
	mov rcx, [rdi+32]  ; rcx = indiceMax
	sal rcx, 3  ; rcx = rcx * 8
	mov r8, [rdi+16]   ; r8 = adresse de mantisse
	xor rdx, rdx    ; rdx = 0 = carry
	
	; ***  calcul du premier chiffre   ***
	mov rax, [r8+rcx]
	div rsi
	mov [r8+rcx], rax
	
	test rax, rax
	jnz boucle
	mov rax, [rdi+32]
	dec rax
	mov [rdi+32], rax 
	js indice_negatif  ; (indiceMax < 0 and rax ==0) => le nombre est zro
	jmp boucle

indice_negatif:
	xor r8, r8
	mov [rdi], r8  ; le nombre est zro !!!
	mov rax, rdx
	ret

boucle:
	sub rcx, 8
	js fin
	mov rax, [r8+rcx]
	div rsi             ; Aie !!!!!
	mov [r8+rcx], rax
	jmp boucle
	
 
fin:
	mov rax, rdx
	ret			; retour  la routine appelante



