;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~        (C) Copyright raphi Software 2004 - All Rights Reserved      ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~ Author : Raphal PASQUIER                                           ~
;~ Email  : raphael.pasquier@neuf.fr                                   ~
;~ Version: 0.0.0.2                                                    ~
;~ Date   : 29/05/2005                                                 ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~    exemple d' utilisation de yasm et du C avec gcc sur GNU/linux    ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~  yasm -m amd64 -f elf software.asm -o software.o                    ~
;~                                                                     ~
;~  gcc -m64 software.o main.c -o main                                 ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~ Description : fait la somme de deux entiers longs positifs          ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BITS 64
	
GLOBAL mulB_R_x86_64_bini


; en C => long int mulB_R_x86_64_bini( Lii* a , unsigned long int m ) ;


mulB_R_x86_64_bini:

	mov rcx, [rdi]  ; rcx = signe de a
	test rcx, rcx
	jnz non_nul
	xor rax, rax
	ret 

non_nul:
	test rsi, rsi
	jnz non_nul_m
	mov QWORD [rdi], 0 ; a.signe = 0
	xor rax, rax 
	ret

	
non_nul_m	
	mov rcx, [rdi+32]  ; rcx = indiceMax
	mov r9, [rdi+16]  ; r9 = adresse de mantisse
	xor r8, r8         ; r8 = 0 = retenue

boucle:
	mov rax, [r9]
	mul rsi
	add rax, r8
	adc rdx, 0
	mov [r9], rax
	mov r8, rdx

	add r9, 8
	jrcxz fin
	dec rcx
	jmp boucle
 
fin:
	test rdx, rdx
	jz fin2           ; pas de retenue

	mov rcx, [rdi+32] ; rcx = indiceMax
	mov r8, [rdi+8]   ; r10 = taille_mantisse
	dec r8
	cmp rcx, r8       ; indiceMax = taille_mantisse - 1 ????
	jz debordement
	mov [r9], rdx     ; a.mantisse[indiceMax+1] = rdx
	inc rcx           ; indiceMax++
	mov [rdi+32], rcx ;  a.inidceMax = indiceMax

fin2:
	xor rax, rax
	ret
	
debordement: 
	mov rax, rdx
	ret			; retour  la routine appelante



